<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Models</h1>

		<p>You are not required to use models in your web application.  They can be used for those people who wish
		to use a more traditional model-view-controller approach.</p>
	</div>

	<div class="content">
		<h1>What is a Model?</h1>

		<p>Models are classes that are designed to handle information in your databases.  An example is if you
		create a blog application using CarbonPHP.  You may have a model class that has methods to insert, update,
		and retrieve blog data.</p>

		<p>An example of this model may look like the following.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blogmodel extends Model<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $title = '';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $content = '';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public $data = '';<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function __construct()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent::__construct();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function get_last_ten_entries()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$query = $this->db->get('entries', 10);<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return $query->result();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function insert()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->title = $_POST['title'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->content = $_POST['content'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->date = time();<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->db->insert('entries', $this);<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function update()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->title = $_POST['title'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->content = $_POST['content'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->date = time();<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->db->update('entries', $this, array('id', $_POST['id']));<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p><i>Note</i>: the above example is using methods from the <b>Active Record</b> data class.</p>
	</div>

	<div class="content">
		<h1>The Anatomy of a Model</h1>

		<p>Models are stored the in <b>application/models/</b> directory.  They can be stored in subdirectories for
		people who wish to use that type of organisation.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Model_name extends Model<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function __construct()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent::__construct();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;			
		</div>

		<p><b>Model_name</b> is the name of your class.  Class names must be capitalised.  You must also make sure
		that the model class extends the base <b>Model</b> class.  The file name will be a lower case version of
		the class name.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class User_model extends Model<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function __construct()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent::__construct();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;			
		</div>

		<p>The model file name will be the following.</p>

		<div class="example">
			application/models/<b>user_model.php</b>
		</div>
	</div>

	<div class="content">
		<h1>Loading a Model</h1>

		<p>Usually your models will be loaded and used from within your controllers methods.</p>

		<div class="example">
			$this->load->model('<b>Model_name</b>');
		</div>

		<p>If you have organised your models in subdirectories you will need to include the directory in the
		method call.</p>

		<div class="example">
			$this->load->model('<b>Directory_name</b>/<b>Model_name</b>');
		</div>

		<p>Once your model has been loaded you will access the models methods using an object with the same
		name as the model class you loaded.</p>

		<div class="example">
			$this->load->mode('<b>Model_name</b>');<br />
			$this-><b>Model_name</b>->method();
		</div>

		<p>You can specify a different name for the model object in the second parameter of the loading method.</p>

		<div class="example">
			$this->load->model('<b>Model_name</b>', '<b>foo</b>');<br />
			$this-><b>foo</b>->method();
		</div>

		<p>An example of a controller that loads and uses a model, then loads a view is shown below.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blog extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function recent()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->load->model('Blog');<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$data['query'] = $this->blog->get_last_ten_entries();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->load->view('blog_view', $data);<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>
	</div>

	<div class="content">
		<h1>Using a Database in Models</h1>

		<p>Unless you autoload the database library (this is explained later) you model will not automaticall connect
		to your database.  There are three methods you can use for connecting to the database in your models.</p>

		<ul>
			<li>Connect using the standard database methods, either in your controller or model class.</li>
			<li>You can tell the model loading method to connect to the database by passing <b>true</b> via
			the third parameter, and settings for your database defined in the configuration file
			<b>config/database.php</b>.</li>

			<div class="example">
				$this->load->model('<b>Model_name</b>', '', true);
			</div>

			<li>You can manually the pass the database connection settings via the third parameter.</li>

			<div class="example">
				$config['hostname'] = 'localhost';<br />
				$config['username'] = 'dbuser';<br />
				$config['passwprd'] = 'dbpassword';<br />
				$config['database'] = 'databasename';<br />
				$config['dbdriver'] = 'mysql';<br />
				$config['dbprefix'] = '';<br />
				$config['pconnect'] = false;<br />
				$config['db_debug'] = true;<br />
				$config['active_r'] = true;<br />
				<br />
				$this->load->model('<b>Model_name</b>', '', $config);
			</div>
		</ul>
	</div>
</body>

</html>
